import time
from time import sleep_ms
from machine import Pin, I2C
from ssd1306 import SSD1306_I2C
import urequests as requests
import network
import ujson
import sys
i2c = I2C(scl=Pin(22),sda=Pin(21),freq=100000)
oled = SSD1306_I2C(128,32,i2c)
oled.fill(0)
oled.text("ESP32 started...",0,0)
oled.show()
#------------------------------------#

active_hour = 0 # set-hour
active_min = 0 # set-min
button_hour = Pin(19,mode=Pin.IN, pull=Pin.PULL_UP) #button-hour
#led = Pin(21, Pin.OUT)
button_min = Pin(18,mode=Pin.IN, pull=Pin.PULL_UP) #button-min
button_con = Pin(17,mode=Pin.IN, pull=Pin.PULL_UP) #button-confirm
button_res = Pin(16,mode=Pin.IN, pull=Pin.PULL_UP) #button-reset
cur_value_hour = button_hour.value()
cur_value_min = button_min.value()
cur_value_con = button_con.value()
cur_value_res = button_res.value()
#------------------------------------#

active_ansX = 0
active_ansY = 0
active_ansZ = 0
button_X = Pin(32,mode=Pin.IN, pull=Pin.PULL_UP) #button-X
button_Y = Pin(33,mode=Pin.IN, pull=Pin.PULL_UP) #button-Y
button_Z = Pin(25,mode=Pin.IN, pull=Pin.PULL_UP) #button-Z
button_ans_con = Pin(26,mode=Pin.IN, pull=Pin.PULL_UP) #button-confirm
button_ans_res = Pin(27,mode=Pin.IN, pull=Pin.PULL_UP) #button-reset
cur_value_x = button_X.value()
cur_value_y = button_Y.value()
cur_value_z = button_Z.value()
cur_value_ans_con = button_ans_con.value()
cur_value_ans_res = button_ans_res.value()



#------------------------------------#

def Set_Hour():
    cur_value = button_hour.value()
    global active_hour
    
    if button_hour.value() != 1:
        print("Start hour")
        active_hour += 1
        if(active_hour == 24): # reset 0 or more than 24 hour
            active_hour = 0
        
        print("Hour: ",active_hour)
        while(True):
            if button_hour.value() == cur_value:
                break
        #print("Finish Hour")
     
        
def Set_Min():
    cur_value = button_min.value()
    global active_min
    if button_min.value() != 1:
        print("Start Min")
        active_min += 1
        if(active_min == 60):
            active_min = 0
                
        print("Min: ",active_min)
        while(True):
            if button_min.value() == cur_value:
                break
        
        
def Set_Confirm():
    global active_hour
    global active_min
    if button_con.value() != 1:
        ADAFRUIT_IO_USERNAME = "dim_thitisak"
        ADAFRUIT_IO_KEY = "aio_JYoJ08q7Yq98FBfbipzw3eafoDDO"
        FEED_KEY = "alarmclock"
        # use adafruit to post and get data
        url = 'https://io.adafruit.com/api/v2/' + ADAFRUIT_IO_USERNAME + '/feeds/' + FEED_KEY + '/data'
        header = {'X-AIO-Key': ADAFRUIT_IO_KEY,
            'Content-Type': 'application/json'}
        time_hour = str(active_hour)
        time_min = str(active_min)
        if len(time_hour) == 1:
            time_hour = "0"+time_hour
        if len(time_min) == 1:
            time_min = "0"+time_min
        set_time = time_hour + ":" + time_min
        d = ujson.dumps({"value":set_time})
        res = requests.post(url, headers=header,data=d)
        
        print("Set Time")
        
def Set_Reset():
    global active_hour
    global active_min
    if button_res.value() != 1:
        print("Reset Time")
        active_hour = 0
        active_min = 0
    

def Number_X():
    cur_value = button_X.value()
    global active_ansX
    if button_X.value() != 1:
        print("Start X")
        active_ansX += 1
        if(active_ansX == 10): # reset 0 or more than value = 10 
            active_ansX = 0
                
        print("Number_X: ",active_ansX)
        while(True):
            if button_X.value() == cur_value:
                break
        
def Number_Y():
    cur_value = button_Y.value()
    global active_ansY
    if button_Y.value() != 1:
        print("Start Y")
        active_ansY += 1
        if(active_ansY == 10): # reset 0 or more than value = 10 
            active_ansY = 0

        print("Number_Y: ",active_ansY)
        while(True):
            if button_Y.value() == cur_value:
                break

def Number_Z():
    cur_value = button_Z.value()
    global active_ansZ
    if button_Z.value() != 1:
        print("Start Z")
        active_ansZ += 1
        if(active_ansZ == 10): # reset 0 or more than value = 10 
            active_ansZ = 0
        
        print("Number_Z: ",active_ansZ)
        while(True):
            if button_Z.value() == cur_value:
                break
def get_ANS():
    ADAFRUIT_IO_USERNAME = "dim_thitisak"
    ADAFRUIT_IO_KEY = "aio_JYoJ08q7Yq98FBfbipzw3eafoDDO"

    FEED_KEY = "ans-x"
    url = 'https://io.adafruit.com/api/v2/' + ADAFRUIT_IO_USERNAME + '/feeds/' + FEED_KEY + '/data'
    header = {'X-AIO-Key': ADAFRUIT_IO_KEY,
        'Content-Type': 'application/json'}
    res = requests.get(url, headers=header)
    ans_x = res.json()[0]['value']
    
    FEED_KEY = "ans-y"
    url = 'https://io.adafruit.com/api/v2/' + ADAFRUIT_IO_USERNAME + '/feeds/' + FEED_KEY + '/data'
    header = {'X-AIO-Key': ADAFRUIT_IO_KEY,
        'Content-Type': 'application/json'}
    res = requests.get(url, headers=header)
    ans_y = res.json()[0]['value']
    
    FEED_KEY = "ans-z"
    url = 'https://io.adafruit.com/api/v2/' + ADAFRUIT_IO_USERNAME + '/feeds/' + FEED_KEY + '/data'
    header = {'X-AIO-Key': ADAFRUIT_IO_KEY,
        'Content-Type': 'application/json'}
    res = requests.get(url, headers=header)
    ans_z = res.json()[0]['value']
    return ans_x,ans_y,ans_z
    
def Confirm_Ans():
    global active_ansX
    global active_ansY
    global active_ansZ
    if button_ans_con.value() != 1:
        x,y,z = get_ANS()
        print("-> ",x,y,z)
        if active_ansX == x and active_ansY == y and active_ansZ == z:
            ADAFRUIT_IO_USERNAME = "dim_thitisak"
            ADAFRUIT_IO_KEY = "aio_JYoJ08q7Yq98FBfbipzw3eafoDDO"
            FEED_KEY = "statusalarm"
            # use adafruit to post and get data
            url = 'https://io.adafruit.com/api/v2/' + ADAFRUIT_IO_USERNAME + '/feeds/' + FEED_KEY + '/data'
            header = {'X-AIO-Key': ADAFRUIT_IO_KEY,
                'Content-Type': 'application/json'}
            d = ujson.dumps({"value":"1"})
            res = requests.post(url, headers=header,data=d)
        
def Reset_Ans():
    global active_ansX
    global active_ansY
    global active_ansZ
    if button_ans_res.value() != 1:
        print("Reset Ans")
        active_ansX = 0
        active_ansY = 0
        active_ansZ = 0
        
def Write_OLED():
    global active_ansX
    global active_ansY
    global active_ansZ
    oled.fill(0)
    oled.text(str(active_hour)+" HR",16,6)
    oled.text(str(active_min)+" MIN",72,6)
    oled.text("X="+str(active_ansX),10,20)
    oled.text("Y="+str(active_ansY),53,20)
    oled.text("Z="+str(active_ansZ),96,20)
    oled.show()
    
def connectWifi(ssid, password):
    wlan = network.WLAN(network.STA_IF)
    if not wlan.active():
        wlan.active(True)

    if not wlan.isconnected():
        wlan.connect(ssid, password)
        print("connecting...")
        timeout = 0
        while not wlan.isconnected() and timeout < 10:
            print(10 - timeout)
            timeout += 1
            time.sleep(1)
    
    if wlan.isconnected():
        print('connected')
        print(wlan.ifconfig())
    else:
        print('not connected')
        sys.exit()
    
connectWifi("DIMMOYeiei","0824503177")

while(True):
    Set_Hour()
    Set_Min()
    Set_Reset()
    Number_X()
    Number_Y()
    Number_Z()
    Reset_Ans()
    Set_Confirm()
    Write_OLED()
    Confirm_Ans()
    sleep_ms(200)