import time
import urequests as requests
import network
import ujson
import sys
from machine import Pin, I2C
from ssd1306 import SSD1306_I2C
i2c = I2C(scl=Pin(22),sda=Pin(21),freq=100000)
oled = SSD1306_I2C(128,64,i2c)
oled.fill(0)
oled.text("ESP32 started...",0,0)
oled.show()
x = "Start"
print("Scanning I2C bus... found",i2c.scan())
time.sleep(0.5)
print("Send data to STM32...")

def connectWifi(ssid, password):
    wlan = network.WLAN(network.STA_IF)
    if not wlan.active():
        wlan.active(True)

    if not wlan.isconnected():
        wlan.connect(ssid, password)
        print("connecting...")
        timeout = 0
        while not wlan.isconnected() and timeout < 10:
            print(10 - timeout)
            timeout += 1
            time.sleep(1)
    
    if wlan.isconnected():
        print('connected')
        print(wlan.ifconfig())
    else:
        print('not connected')
        sys.exit()
    
connectWifi("DIMMOYeiei","0824503177")
while True:
    new_x = i2c.readfrom(0x50,5)
    #print(new_x)
    new_x = new_x.decode("utf-8")
    new_x = new_x.strip()
    #print(new_x)
    oled.fill(0)
    x = "What is answer of " + str(new_x)
    x = x.split()
    x[len(x)-1] = x[len(x)-1][:x[len(x)-1].find("\x00")]
    if x[len(x)-1] == '':
        x[len(x)-1] = '0'
    x.append("mod 9")
    print(x)
    pos_x = 0
    pos_y = 0
    for i in range(len(x)):
        if pos_x + len(x[i])*8 > 128:
            pos_x = 0
            pos_y = pos_y+8
        #print(pos_x,pos_y)
        oled.text(x[i],pos_x,pos_y)
        pos_x += (len(x[i])+1)*8
    oled.show()
    old_x = x
    ADAFRUIT_IO_USERNAME = "dim_thitisak"
    ADAFRUIT_IO_KEY = "aio_JYoJ08q7Yq98FBfbipzw3eafoDDO"
    #print("-> ",new_x)
    FEED_KEY = "ans-y"
    # use adafruit to post and get data
    
    url = 'https://io.adafruit.com/api/v2/' + ADAFRUIT_IO_USERNAME + '/feeds/' + FEED_KEY + '/data'
    header = {'X-AIO-Key': ADAFRUIT_IO_KEY,
        'Content-Type': 'application/json'}
    d = ujson.dumps({"value":str(int(x[4])%9)})
    res = requests.post(url, headers=header,data=d)
    
    res.close()
    time.sleep(0.5)