/* mbed Microcontroller Library
 * Copyright (c) 2019 ARM Limited
 * SPDX-License-Identifier: Apache-2.0
 */

#include "DebounceIn.h"
#include "OLEDDisplay.h"
#include "mbed.h"
#include "time.h"
#include <stdlib.h>
#include "stdlib.h"

OLEDDisplay oled;
DebounceIn sw(D3, PullUp);
I2CSlave slave(D4, D5);

char ans[15];
int main() {
  char buf[55];
  srand(time(0));
  int rand_n = rand()%1000;
  oled.printf("Test");
  slave.address(0xA0); // actual address = 0x50 (last bit ignored)
  while (1) {
    int i = slave.receive();
    for (int i = 0; i < sizeof(buf); i++)
      buf[i] = 0; // Clear buffer

    switch (i) {
    case I2CSlave::ReadAddressed:
      if (!sw) // switch pressed
      {
        rand_n = rand()%1000;
        sprintf(ans,"%d",rand_n);
        slave.write(ans, 50);
      } else {
        slave.write(ans, 50);
      }
      break;
    case I2CSlave::WriteAddressed:
      slave.read(buf, sizeof(buf) - 1);
      break;
    }
  }
}
